-
Notifications
You must be signed in to change notification settings - Fork 0
/
Easy_JudgingCircle_657.java
91 lines (76 loc) · 2.94 KB
/
Easy_JudgingCircle_657.java
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
79
80
81
82
83
84
85
86
87
88
89
90
91
package Leetcode;
import java.util.HashMap;
/*
There is a robot starting at position (0, 0), the origin, on a 2D plane.
Given a sequence of its moves, judge if this robot ends up at (0, 0) after it completes its moves.
The move sequence is represented by a string, and the character moves[i] represents its ith move.
Valid moves are R (right), L (left), U (up), and D (down).
If the robot returns to the origin after it finishes all of its moves, return true. Otherwise, return false.
Note: The way that the robot is "facing" is irrelevant.
"R" will always make the robot move to the right once, "L" will always make it move left, etc.
Also, assume that the magnitude of the robot's movement is the same for each move.
Example 1:
Input: "UD"
Output: true
Explanation: The robot moves up once, and then down once.
All moves have the same magnitude, so it ended up at the origin where it started. Therefore, we return true.
Example 2:
Input: "LL"
Output: false
Explanation: The robot moves left twice. It ends up two "moves" to the left of the origin.
We return false because it is not at the origin at the end of its moves.
*/
public class Easy_JudgingCircle_657 {
public static void main(String[] args){
String test = "LLRRDDUUU";
boolean result = judgeCircle_v3(test);
System.out.println(result);
}
// HashMap存储<K,V> pair, time o(n)
// Runtime: 25 ms, faster than 10.37% of Java online submissions
private static boolean judgeCircle(String moves){
HashMap<Character, Integer> hm = new HashMap<>();
for(Character c : moves.toCharArray()){
if(!hm.containsKey(c)){
hm.put(c, 1);
}
else{
hm.put(c, hm.get(c) + 1);
}
}
System.out.println(hm.size());
if(hm.size() == 1){
return false;
}
else if(hm.size() == 2 && !hm.containsKey('U') && !hm.containsKey('D') && hm.get('L').equals(hm.get('R'))){
return true;
}
else if(hm.size() == 2 && !hm.containsKey('L') && !hm.containsKey('R') && hm.get('U').equals(hm.get('D'))){
return true;
}
else if(hm.size() == 4 && hm.get('U').equals(hm.get('D')) && hm.get('L').equals(hm.get('R'))){
return true;
}
else{
return false;
}
}
private static boolean judgeCircle_v2(String moves){
int[] cnt = new int[128];
for(char c : moves.toCharArray()){
cnt[c]++;
}
return cnt['L'] == cnt['R'] && cnt['U'] == cnt['D'];
}
private static boolean judgeCircle_v3(String moves){
int x = 0;
int y = 0;
for(char c : moves.toCharArray()){
if(c == 'D') x++;
else if(c == 'U') x--;
else if(c == 'L') y++;
else if(c == 'R') y--;
}
return x== 0 && y == 0;
}
}